/**********************************************************************
* procedure : Final Semester Project
*
*      file : ethhead.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Displays Ether header information to log file
*
*     usage : void eth_header(IP_HEADER far *header);
*
* exit code : None
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>		// for gettime and getdate

#include "pktdrvr.h"
#include "ether.h"
#include "snoop.h"

void eth_header(ETH_HEADER far *MAC_header, unsigned length) {
	char far *srcalias;
	char far *dstalias;

	srcalias = NULL;
	dstalias = NULL;

	if (eth_alias((char far *)(MAC_header->src),&srcalias))
		fprintf(log_file,"  Ether: len %4u  src %-17Fs  dst ",length,
						srcalias);
	else fprintf(log_file,"  Ether: len %4u  src %.2X:%.2X:%.2X:%.2X:%.2X:%.2X  dst ",
							 length,
							 MAC_header->src[0],MAC_header->src[1],MAC_header->src[2],
							 MAC_header->src[3],MAC_header->src[4],MAC_header->src[5]);

	if (eth_alias((char far *)(MAC_header->dst),&dstalias))
		fprintf(log_file,"%-17Fs  type ",dstalias);
	else fprintf(log_file,"%.2X:%.2X:%.2X:%.2X:%.2X:%.2X  type ",
							 MAC_header->dst[0],MAC_header->dst[1],MAC_header->dst[2],
							 MAC_header->dst[3],MAC_header->dst[4],MAC_header->dst[5]);

	switch(MAC_header->type) {
	case ETHER_NS_IDP:
		fprintf(log_file,"Xerox NS IDP");
		break;
	case ETHER_IP:
		fprintf(log_file,"IP");
		break;
	case ETHER_X75:
		fprintf(log_file,"X.75 internet");
		break;
	case ETHER_NBS:
		fprintf(log_file,"NBS internet");
		break;
	case ETHER_ECMA:
		fprintf(log_file,"ECMA internet");
		break;
	case ETHER_CHAOS:
		fprintf(log_file,"ChaosNet");
		break;
	case ETHER_X25:
		fprintf(log_file,"X.25, level 3");
		break;
	case ETHER_ARP:
		fprintf(log_file,"ARP");
		break;
	case ETHER_XNS:
		fprintf(log_file,"XNS compatibility");
		break;
	case ETHER_DEC:
		fprintf(log_file,"DECnet, phase IV");
		break;
	case ETHER_VLN:
		fprintf(log_file,"Cronus VLN");
		break;
	case ETHER_HP:
		fprintf(log_file,"HP Probe");
		break;
	case ETHER_NESTAR:
		fprintf(log_file,"Nestar");
		break;
	case ETHER_EXCELAN:
		fprintf(log_file,"Excelan");
		break;
	case ETHER_RARP:
		fprintf(log_file,"reverse ARP");
		break;
	case ETHER_LAN:
		fprintf(log_file,"DEC LANbridge");
		break;
	case ETHER_APPLE:
		fprintf(log_file,"Appletalk");
		break;
	case ETHER_LOOP:
		fprintf(log_file,"loopback");
		break;
	default:
		fprintf(log_file,"unknown");
	}

	fprintf(log_file,"\n");

}