/**********************************************************************
* procedure : Final Semester Project
*
*      file : pktdrvr.h
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Defines, prototypes, and structs for use with pktdrvr
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Version 1.0
*
***********************************************************************/

/* info.drvr_functionality bit field */
#define EXTENDED	0x2
#define HIGH_PERF	0x4

/* recv_mode types */
#define	RCVR_OFF						1
#define RCVR_THIS_IF_ONLY		2
#define RCVR_BROADCAST 			3
#define RCVR_LIMITED_MULTI	4
#define RCVR_ALL_MULTI			5
#define RCVR_PERMISCUOUS		6

/* drvr_info structure expected as returned from DRVRINFO */
typedef struct {
	char			drvr_functionality;
	int	  		drvr_version;
	char     	drvr_class;
	char      drvr_number;
	int	      drvr_type;
	char far *drvr_name;
} DRVR_INFO;

/* access_type structure expected as retured from ACCTYPE */
typedef struct {
	char	 	 	if_class;
	int	  		if_type;
	char	  	if_number;
	char far *type;
	int  	  	typelen;
	int	(far *receiver_ptr)();
} ACCESS_TYPE;

/* assembly language codes... */
int pkt_find(void);     			/* Find packet driver interrupt */

int drvrinfo(int, DRVR_INFO far *);	/* ARG1: interrupt vector
						 ARG2: pointer to driver_info */

int acctype(int, ACCESS_TYPE far *);	/* ARG1: interrupt vector
						 ARG2: pointer to access_type */

far receiver(void);

int reltype(int, int);

void set_recv(int, int, int);

/* pktdrvr.c */
int get_drvrinfo(FILE *output, int pktdrvint, DRVR_INFO far *info);

int access_type_all(int pktdrvint, DRVR_INFO far *info,
										ACCESS_TYPE far *access);

