/**********************************************************************
* procedure : Final Semester Project
*
*      file : snoop.h
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Defines, externs, and prototypes for use with utils
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Version 1.0
*
***********************************************************************/

#define MAXOPT							128			// option file max number of lines
#define OPTBUFSIZ						81			// option file max line length

#ifndef  SNOOP_MAIN
	extern volatile unsigned long int  discarded_pkts;
	extern unsigned long int  	 			 received_pkts;
	extern unsigned long int					 filtered_out_pkts;

	extern char												 character_mode;
	extern char												 nofilter_flag;
	extern char												 verbose_mode;

	extern FILE												*log_file;
#endif

/* utils.c */
int hex2dec(char value);

void display_stats(FILE *output);

int read_optfile(char *filename);

int	parse_options(int N_options, char *options[]);

void current_stats(void);

void farnearstrcpy(char far *, char *);

void display_timestamp(void);

void type_swap(unsigned int far *buf);

void usage(void);