/**********************************************************************
* procedure : Final Semester Project
*
*      file : ip.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : To allocate memory for IP filtering
*
*   actions : 1. Allocates and clears memory for IP filtering
*
*     usage : void ip_clear_table();
*
* exit code : None
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>

#include "pktdrvr.h"
#include "ether.h"
#include "ip.h"
#include "snoop.h"

void ip_clear_table() {
	int i;
	int j;

	ip_src_tbl   = (IP_ADDR_TBL far *)farmalloc(IP_TABLE_LEN*
									sizeof(IP_ADDR_TBL));
	if(!ip_src_tbl) {
		fprintf(stderr,"Could not allocate memory for ip_src_tbl in clear_table.\n");
		exit(1);
	}

	ip_dst_tbl   = (IP_ADDR_TBL far *)farmalloc(IP_TABLE_LEN*
									sizeof(IP_ADDR_TBL));
	if(!ip_dst_tbl) {
		fprintf(stderr,"Could not allocate memory for ip_dst_tbl in clear_table.\n");
		exit(1);
	}

	ip_alias_tbl = (IP_ALIAS_TBL far *)farmalloc(IP_TABLE_LEN*
									sizeof(IP_ALIAS_TBL));
	if(!ip_alias_tbl) {
		fprintf(stderr,"Could not allocate memory for ip_alias_tbl in clear_table.\n");
		exit(1);
	}

	ip_type_tbl  = (IP_TYPE_TBL far *)farmalloc(IP_TABLE_LEN*
									sizeof(IP_TYPE_TBL));
	if(!ip_type_tbl) {
		fprintf(stderr,"Could not allocate memory for ip_type_tbl in clear_table.\n");
		exit(1);
	}


	for (i=0; i < IP_TABLE_LEN; i++) {
		for (j=0; j < IP_ADDR_LEN; j++)
			ip_src_tbl[i].addr[j]  	= ip_dst_tbl[i].addr[j]
															= ip_alias_tbl[i].addr[j] = 0;

		ip_alias_tbl[i].alias[0] 	= '\0';

		ip_src_tbl[i].logicop    	= ip_dst_tbl[i].logicop
															= IP_OR | IP_NOT_NOT;

		ip_src_tbl[i].class				= ip_dst_tbl[i].class 	 = 'd';

		ip_src_tbl[i].index      	= ip_dst_tbl[i].index    = 0;

		ip_type_tbl[i].type		  	= 0;
	}

	return;
}

