/**********************************************************************
* procedure : Final Semester Project
*
*      file : ipfltr.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Compares IP address and Types with filter list
*
*     usage : int ip_addr_filter(IP_HEADER far *buf);
*             int ip_type_filter(IP_HEADER far *buf);
*
* exit code : 1 = Match, 0 = No Match
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "ether.h"
#include "ip.h"
#include "snoop.h"

int cmp_ip_addr(char far *addr1, char far *addr2, char class) {
	int i;
	int flag=1;

	for(i=0; (i < (class+1-'a')) && flag; i++)
		if(addr1[i]!=addr2[i]) flag=0;

	return(flag);
}

int cmp_ip_type(unsigned char type1, unsigned char type2) {
	return(type1==type2);
}

int ip_addr_filter(IP_HEADER far *buf) {
	int index;
	int	ipaddr_flag=0;

	for(index=0; (index < ip_src_index) && !ipaddr_flag;
																						index++) {  // find source match
		ipaddr_flag = cmp_ip_addr(ip_src_tbl[index].addr,buf->src,
															ip_src_tbl[index].class);
		if (ipaddr_flag)													   // check for dest AND match
			if ((ip_src_tbl[index].logicop & IP_ANDOR_MASK) == IP_AND)
				ipaddr_flag =
					cmp_ip_addr(ip_dst_tbl[ip_src_tbl[index].index].addr,buf->dst,
											ip_dst_tbl[ip_dst_tbl[index].index].class);
	}

	for(index=0; (index < ip_dst_index) && !ipaddr_flag; index++) {
		ipaddr_flag = cmp_ip_addr(ip_dst_tbl[index].addr,buf->dst,
															ip_dst_tbl[index].class);
			if (ipaddr_flag)
			if ((ip_dst_tbl[index].logicop & IP_ANDOR_MASK) == IP_AND)
				ipaddr_flag =
					cmp_ip_addr(ip_src_tbl[ip_dst_tbl[index].index].addr,buf->src,
											ip_src_tbl[ip_dst_tbl[index].index].class);
	}

	return(ipaddr_flag);
}

int ip_type_filter(IP_HEADER far *buf) {
	int index;
	int	iptype_flag;

	for(index=0; (index < ip_type_index) && !iptype_flag; index++)
		iptype_flag = cmp_ip_type(ip_type_tbl[index].type,buf->type);

	if(ip_type_index==0) iptype_flag=1;

	return(iptype_flag);
}

int ip_alias(char far *addr, char far **returnstr) {
	int 						 index;
	int			  			 ipaddr_flag=0;

	*returnstr = NULL;

	for(index=0; (index < ip_alias_index) && !ipaddr_flag; index ++) {
		ipaddr_flag = cmp_ip_addr(ip_alias_tbl[index].addr,addr,'d');
		if (ipaddr_flag)
			if (ip_alias_tbl[index].alias[0])
				*returnstr = (char far *)ip_alias_tbl[index].alias;
			else ipaddr_flag = 0;
	}


	return(ipaddr_flag);
}



