;**********************************************************************
; procedure : Final Semester Project
;
;      file : acctype.asm
;
;       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
;							all rights reserved
;
;   project : snoop.exe
;
;   purpose : Set up for and call access_type from packet driver
;
;   actions : 1. Sets typelen=0, implying permiscious mode
;							2. First call: requests a buffer from the packet driver
;							3. Second call: returns with full buffer
;
;     usage : AX = 0 	=> first call
;							ES:DI 	=> contains pointer to buffer
;							CX			=> packet length
;							AX = 1 	=> second call
;
; exit code : (see usage)
;
;   authors : Brendan D. Donahe and
;							Jerome C. Parks,
;							New Mexico State University, EE 464
;
;  language : Borland International C/C++, version 2.0
;							plus corresponding assembler and linker
;
;   history : December 13, 1996,  Verion 1.0
;
;**********************************************************************/

.MODEL SMALL,C

INCLUDE pktdrvr.inc

PUBLIC acctype

.CODE

acctype		PROC

		ARG	int_vect:WORD,access_type_ptr:FAR
		LOCAL	int_vect_addr:DWORD
		USES	bx,cx,dx,ds,es,si,di

		mov		ax,int_vect									; load interrupt vector number
		mov		cl,2H	   										; interrupt vect number * 4
		shl		ax,cl

		mov		bx,ax												; offset into vector table

		mov 	dx,0000H
		mov		es,dx   										; make ES point to segment of IVT
		mov		cx,WORD PTR [es:bx]					; get offset
		mov		WORD PTR [int_vect_addr],cx
		mov		cx,WORD PTR [es:bx+2]				; get segment
		mov		WORD PTR [int_vect_addr+2],cx

		les		bx,DWORD PTR [access_type_ptr]
		mov		ax,WORD PTR [es:bx.if_type]
		push	ax
		mov   ah,2H           						; prepare to call access_type
		mov   al,BYTE PTR [es:bx.if_class]
;		mov		cx,WORD PTR [es:bx.typelen]
		mov		cx,0H
		mov		dl,BYTE PTR [es:bx.if_number]
		lds		si,DWORD PTR [es:bx.type_acc]
		les		di,DWORD PTR [es:bx.receiver_ptr]
		pop		bx

		pushf
		call    DWORD PTR [int_vect_addr]

		jnc	exit
		neg	dh
		mov	al, dh
		cbw

exit:
		ret
ENDP

END
