/**********************************************************************
* procedure : Final Semester Project
*
*      file : pktdrvr.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Communicate with the assembly code and packet driver
*
*   actions : 1. Get the information about the packet driver
*							2. Set the packet driver in permiscious mode
*
*     usage : int get_drvrinfo(FILE *output, int pktdrvint,
*															 DRVR_INFO far *info);
*							int access_type_all(int pktdrvint, DRVR_INFO far *info,
*																	ACCESS_TYPE far *access);
*
* exit code : Different for individual routines
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <string.h>
#include "pktdrvr.h"

int get_drvrinfo(FILE *output, int pktdrvint, DRVR_INFO far *info) {
	int 			return_code=0;
	char far *ptr;

	return_code = drvrinfo(pktdrvint, info);

	if(return_code) {
			ptr = _fstrchr((char far *)(info->drvr_name), '$');
			if(ptr)
				*ptr = '\0';

			fprintf(output,"         Name -  %Fs\n",info->drvr_name);
			fprintf(output,"\t\tFunctionality -  basic %s%s\n",
				(info->drvr_functionality&EXTENDED)?("extended "):(""),
				(info->drvr_functionality&HIGH_PERF)?("high-performance "):(""));
			fprintf(output,"\t\t      Version -  %u",info->drvr_version);
			fprintf(output,"\t\t Class -  %u\n",info->drvr_class);
			fprintf(output,"\t\t       Number -  %u",info->drvr_number);
			fprintf(output,"\t\t  Type -  %u\n",info->drvr_type);

	}

	return(return_code);
}


int access_type_all(int pktdrvint, DRVR_INFO far *info,
										ACCESS_TYPE far *access) {
	access->if_class  = info->drvr_class;
	access->if_type   = info->drvr_type;
	access->if_number = info->drvr_number;
	access->typelen   = 0;			/* if typelen=0, match all pkts */
	access->receiver_ptr  = receiver;
	return(acctype(pktdrvint, access));
}
