;**********************************************************************
; procedure : Final Semester Project
;
;      file : setrecv.asm
;
;       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
;							all rights reserved
;
;   project : snoop.exe
;
;   purpose : To set the receive mode of the packet driver to permiscious
;
;     usage : AH => 20
;							BX => handle
;							CX => mode (6 = all packets)
;
;		 actions: 1. Load the registers as per usage
;
; exit code : DH => error code
;
;   authors : Brendan D. Donahe and
;							Jerome C. Parks,
;							New Mexico State University, EE 464
;
;  language : Borland International C/C++, version 2.0
;							plus corresponding assembler and linker
;
;   history : December 13, 1996,  Verion 1.0
;
;**********************************************************************/

.MODEL SMALL,C

INCLUDE pktdrvr.inc

PUBLIC set_recv

.CODE

set_recv		PROC

		ARG		int_vect:WORD,handle:WORD,mode:WORD
		LOCAL	int_vect_addr:DWORD
		USES	bx,cx,dx,ds,es,si,di

		mov		ax,int_vect	; load interrupt vector number
		mov		cl,2H	   		; interrupt vect number * 4
		shl		ax,cl

		mov		bx,ax				; offset into vector table

		mov 	dx,0000H
		mov		es,dx   		; make ES point to segment of IVT
		mov		cx,WORD PTR [es:bx]	; get offset
		mov		WORD PTR [int_vect_addr],cx
		mov		cx,WORD PTR [es:bx+2]	; get segment
		mov		WORD PTR [int_vect_addr+2],cx

		mov		ah,14H			; prepare to call setrecv
		mov		bx,handle
		mov	  cx,mode

		pushf
		call  DWORD PTR [int_vect_addr]

exit:
		ret
ENDP

END
