/**********************************************************************
* procedure : Final Semester Project
*
*      file : timestamp.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Prints time stamp on each packet
*
*   actions : 1. Calls gettime() and getdate()
*							2. Performs fprintf() on time and date
*
*     usage : void display_timestamp();
*
* exit code : None
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>		// for gettime and getdate

#include "snoop.h"

void display_timestamp(void) {
	struct time t;
	struct date	d;

	gettime(&t);
	getdate(&d);

	fprintf(log_file,
				 "At %02d:%02d:%02d.%02d on %02d/%02d/%02d packet received:\n",
				 t.ti_hour,t.ti_min,t.ti_sec,t.ti_hund,
				 d.da_mon,d.da_day,d.da_year);
}