/**********************************************************************
* procedure : Final Semester Project
*
*      file : usage.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : To explain to the user all the possible command line args
*
*   actions : 1. Display all command line arguments
*
*     usage : void usage();
*
* exit code : None
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "snoop.h"


void usage() {
	fprintf(stdout,"\nusage: snoop {options(s)} {filename(s)}\n\n");

	fprintf(stdout,"       options: (preceeded by either '-' or '/'\n");
	fprintf(stdout,"                 -c  (prints ASCII characters from telnet session)\n\n");
	fprintf(stdout,"                 -eb={ethernet both (source(alias),destination(alias))}\n");
	fprintf(stdout,"                 -ed={ethernet destination address(alias)} \n");
	fprintf(stdout,"                 -ee={ethernet either address(alias)} \n");
	fprintf(stdout,"                 -eh={ethernet host table entry(alias)} \n");
	fprintf(stdout,"                 -es={ethernet source address(alias)} \n");
	fprintf(stdout,"                 -et={ethernet type}\n\n");
	fprintf(stdout,"                 -h  (help command)\n");
	fprintf(stdout,"                 -?  (help command)\n\n");
	fprintf(stdout,"                 -ib={IP both (source(alias),destination(alias))} \n");
	fprintf(stdout,"                 -id={IP destination address(alias)} \n");
	fprintf(stdout,"                 -ie={IP either address(alias)} \n");
	fprintf(stdout,"                 -ih={IP host table entry(alias)} \n");
	fprintf(stdout,"                 -is={IP source address(alias)} \n");
	fprintf(stdout,"                 -it={IP type}\n\n");

	fprintf(stdout," - Hit any key for more... -\n");
	while(!kbhit());

	fprintf(stdout,"\n\n                 -l={log file}\n\n");
	fprintf(stdout,"                 -tt={TCP type}\n\n");
	fprintf(stdout,"                 -v  (verbose mode for script files)\n\n");

	fprintf(stdout,"       filenames: any valid MS-DOS name (.opt default)\n");
	fprintf(stdout,"                  # - verbose comment\n");
	fprintf(stdout,"                  ; - mute comment\n");
	fprintf(stdout,"                  {options} - only one argument per line\n");
	fprintf(stdout,"                  {filename} - include other script files (only one per line)\n\n");

	fprintf(stdout,"                  <esc> key terminates execution\n\n");
}