/**********************************************************************
* procedure : Final Semester Project
*
*      file : utils.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Acts as a general purpose file holding subroutines
*							unique to primarily snoop.c
*
*
*   actions : 1. Convert hexadecimal to decimal values
*							2. Print out statistics, either on exit, or continuously
*							3. Creat a far to near string copy routine
*							4. Perform Byte swapping on values
*
*     usage : int hex2dec(char value);
*							void display_stats(FILE *output);
*							void current_stats();
*             void farnearstrcpy(char far *dst, char *src);
*             void type_swap(unsigned int far *buf);
*
* exit code : Different for individual routines
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>		 // for gotoxy, wherex, wherey

#include "snoop.h"


int hex2dec(char value) {
	if ((value >= '0') && (value <= '9'))
		return(value-'0');
	if ((toupper(value) >= 'A') && (toupper(value) <= 'F'))
		return(10 + toupper(value) - 'A');
	return(-1);
}

void display_stats(FILE *output) {
	fprintf(output,"\nPacket statistics:  Reported -  %10lu     ",
					received_pkts);
	fprintf(output,  "            Lost -  %10lu\n",
					discarded_pkts);
	fprintf(output,  "        Discarded (filtered) -  %10lu     ",
					filtered_out_pkts);
	fprintf(output,  "Received (total) -  %10lu\n",
					received_pkts+filtered_out_pkts);
	return;
}


void current_stats() {
	int x;
	int y;

	x=wherex();
	y=wherey();

	gotoxy(1,y-3);

	display_stats(stdout);

	gotoxy(x,y);
}

void farnearstrcpy(char far *dst, char *src) {
	int i;

	for(i=0; src[i]; i++) dst[i] = src[i];
	dst[i] = '\0';
}

void type_swap(unsigned int far *buf) {
	*buf = (*buf >> 8) + (*buf << 8);
	return;
}

