/**********************************************************************
* procedure : Final Semester Project
*
*      file : tcp.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : To clear out all tables used in TCP filtering
*
*   actions : 1. Allocating memory for TCP filtering
*
*     usage : void tcp_clear_table();
*
* exit code : None
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/


#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>

#include "pktdrvr.h"
#include "ether.h"
#include "ip.h"
#include "tcp.h"
#include "snoop.h"

void tcp_clear_table() {
	int i;
	int j;

	tcp_src_tbl   = (TCP_PORT_TBL far *)farmalloc(TCP_TABLE_LEN*
									sizeof(TCP_PORT_TBL));
	if(!tcp_src_tbl) {
		fprintf(stderr,"Could not allocate memory for tcp_src_tbl in clear_table.\n");
		exit(1);
	}

	tcp_dst_tbl   = (TCP_PORT_TBL far *)farmalloc(TCP_TABLE_LEN*
									sizeof(TCP_PORT_TBL));
	if(!tcp_dst_tbl) {
		fprintf(stderr,"Could not allocate memory for tcp_dst_tbl in clear_table.\n");
		exit(1);
	}

	tcp_alias_tbl = (TCP_ALIAS_TBL far *)farmalloc(TCP_TABLE_LEN*
									sizeof(TCP_ALIAS_TBL));
	if(!tcp_alias_tbl) {
		fprintf(stderr,"Could not allocate memory for tcp_alias_tbl in clear_table.\n");
		exit(1);
	}

	tcp_type_tbl  = (TCP_TYPE_TBL far *)farmalloc(TCP_TABLE_LEN*
									sizeof(TCP_TYPE_TBL));
	if(!tcp_type_tbl) {
		fprintf(stderr,"Could not allocate memory for tcp_type_tbl in clear_table.\n");
		exit(1);
	}


	for (i=0; i < TCP_TABLE_LEN; i++) {
		tcp_src_tbl[i].port	= tcp_dst_tbl[i].port =
													tcp_alias_tbl[i].port = 0;

		tcp_alias_tbl[i].alias[0] 	= '\0';

		tcp_src_tbl[i].logicop    	= tcp_dst_tbl[i].logicop
																= TCP_OR | TCP_NOT_NOT;

		tcp_src_tbl[i].index      	= tcp_dst_tbl[i].index    = 0;

		tcp_type_tbl[i].type		  	= 0;
	}

	return;
}

