/**********************************************************************
* procedure : Final Semester Project
*
*      file : tcpfilter.c
*
*       			(C) 1996, Brendan D. Donahe and Jerome C. Parks,
*							all rights reserved
*
*   project : snoop.exe
*
*   purpose : Filter based on TCP filter list
*
*   actions : 1. Decide if source or destination port matches
*								 filter type
*
*     usage : int tcp_type_filter(TCP_HEADER far *buf);
*
* exit code : 1 = True, 0 = False
*
*   authors : Brendan D. Donahe and
*							Jerome C. Parks,
*							New Mexico State University, EE 464
*
*  language : Borland International C/C++, version 2.0
*							plus corresponding assembler and linker
*
*   history : December 13, 1996,  Verion 1.0
*
***********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "ether.h"
#include "ip.h"
#include "tcp.h"
#include "snoop.h"

int cmp_tcp_type(unsigned int port1, unsigned int port2) {
	return(port1==port2);
}

int tcp_type_filter(TCP_HEADER far *buf) {
	int index;
	int	tcptype_flag=0;

	for(index=0; (index < tcp_type_index) && !tcptype_flag;
																						index++) {  // find source match
		tcptype_flag = cmp_tcp_type(tcp_type_tbl[index].type,buf->src) ||
									 cmp_tcp_type(tcp_type_tbl[index].type,buf->dst);
	}

	if(tcp_type_index==0) tcptype_flag=1;

	return(tcptype_flag);
}

